<?php

class model_component_pro100_answers extends model {

  function get_col(){
    return 5;
  }

  public function escape($string)
  {
	return SQLite3::escapeString($string);//Не для запросов внутри "" !
  }  
  
  function connect(){
	  $db=new PDO("sqlite:db.sqlite");
	  return $db;
  }

  function add_ans($q,$aut,$ans){
	  $db=$this->connect();    
	  $insert_query="INSERT INTO 'pro100_answers' ('question', 'autor', 'answer') VALUES ('".$q."', '".$this->escape($aut)."', '".$this->escape($ans)."')";
	  $ins=$db->exec($insert_query);
	  return $ins;
  }

  function add_question($aut,$q){
	  $db=$this->connect();    	      
	  $insert_query="INSERT INTO 'pro100_questions' ('autor', 'question') VALUES ('".$this->escape($aut)."', '".$this->escape($q)."')";
	  $ins=$db->exec($insert_query);
	  return 0;
  }

  function get_questions($npage){
	  $db=$this->connect();    
	  $col=$this->get_col();
	  $num=($npage-1)*$col;
	  $select_query="SELECT * FROM pro100_questions ORDER BY id DESC";
	  $st=$db->query($select_query);
	  $i=1;
	  $arr=array();
	  while($arri=$st->fetch()){
		  if (($i>$num) and ($i<=$num+$col)){
		    $arr[$i]=$arri;	    
	        $select_query1="SELECT * FROM pro100_answers WHERE question=".$arr[$i]["id"];
		    $st1=$db->query($select_query1);
	        $arr[$i]["num"]=count($st1->fetchAll());
		  }
		  $i++;
	  }
	  return($arr);	  	  
  }

  function get_question($id){
	  $db=$this->connect();    
	  $select_query="SELECT * FROM pro100_questions WHERE id=".$id;
	  $st=$db->query($select_query);
	  $arr=$st->fetch();
	  return($arr);
  }

  function get_answer($id){
	  $db=$this->connect();    
	  $select_query="SELECT * FROM pro100_answers WHERE id=".$id;
	  $st=$db->query($select_query);
	  $arr=$st->fetch();
	  return($arr);
  }
  
  
  function get_answers($id, $npage){
	  $db=$this->connect();    
	  $col=$this->get_col();
	  $num=($npage-1)*$col;
	  if ($id==0) $select_query1="SELECT * FROM pro100_answers ORDER BY id DESC";
	  else $select_query1="SELECT * FROM pro100_answers WHERE question=".$id." ORDER BY id DESC";
	  $st1=$db->query($select_query1);
	  $arr=array();
	  $i=1;
	  $arr=array();
	  while($arri=$st1->fetch()){
		  if (($i>$num) and ($i<=$num+$col)){
	       $arr[$i]=$arri;
		   $qq = $this->get_question($arri["question"]);
		   $arr[$i]["question"] = $qq["question"];////////////
	      }
		$i++;
	  }
	  return($arr);
  }
  
  function q_count_pages(){
    $db=$this->connect();
	$select_query="SELECT * FROM pro100_questions ORDER BY id DESC";
	$st=$db->query($select_query);
	$count=count($st->fetchAll());
	$col=$this->get_col();//количество на странице
	$num=($count%$col==0)?$count/$col:($count-($count%$col))/$col+1;
	return($num);
  }
  
  function a_count_pages($q){
    $db=$this->connect();
	if ($q==0)$select_query="SELECT * FROM pro100_answers ORDER BY id DESC";
	else $select_query="SELECT * FROM pro100_answers WHERE question=".$q." ORDER BY id DESC";
	$st=$db->query($select_query);
	$count=count($st->fetchAll());
	$col=$this->get_col();//количество на странице
	$num=($count%$col==0)?$count/$col:($count-($count%$col))/$col+1;
	return($num);    
  }
  
  function del_question($id_quest){
    $db=$this->connect();
	if ($id_quest<=0) return 0;
    $sql="DELETE FROM pro100_questions WHERE id=".$id_quest." LIMIT 1";
	return $db->exec($sql);
  }

  function del_answer($id_ans){
    $db=$this->connect();
	if ($id_ans<=0) return 0;
    $sql="DELETE FROM pro100_answers WHERE id=".$id_ans." LIMIT 1";
	return $db->exec($sql);
  }
  
  function edit_answer($a, $autor, $answer){
    $db=$this->connect();
	$update_query="UPDATE pro100_answers SET autor='".$this->escape($autor)."', answer='".$this->escape($answer)."' WHERE id=".$a;
	return $db->exec($update_query);  
  }
  
}