<?php

class model_component_pro100_answers extends model {
	
  function get_col(){
    return 5;
  }

  public function escape($string)
  {
	return SQLite3::escapeString($string);//Не для запросов внутри '' !
  }
  
  public function mesmsg($mes){
    if ($mes==1) return "Ваш вопрос добавлен!";
  }
  
  function add_ans($q,$aut,$ans){
	  $db=new PDO('sqlite:db.sqlite');
	  $insert_query="INSERT INTO 'pro100_answers' ('question', 'autor', 'answer') VALUES ('".$this->escape($q)."', '".$this->escape($aut)."', '".$this->escape($ans)."')";
	  $ins=$db->exec($insert_query);
	  return $ins;
  }

  function add_question($aut,$q){
	  $db=new PDO('sqlite:db.sqlite');
	  $insert_query="INSERT INTO 'pro100_questions' ('autor', 'question') VALUES ('".$this->escape($aut)."', '".$this->escape($q)."')";
	  $ins=$db->exec($insert_query);
	  return $ins;
  }

  function get_All_questions($findtext){
	  mb_internal_encoding("utf-8");
	  $db=new PDO('sqlite:db.sqlite');
	  $select_query='SELECT * FROM pro100_questions ORDER BY id DESC';
	  $st=$db->query($select_query);
	  $i=1;
	  $arr=array();
	  while($arri=$st->fetch()){
		  if ($findtext!="") if (strpos(mb_strtoupper($arri["question"]), mb_strtoupper($findtext))===FALSE) continue;
		  $arr[$i]=$arri;	    
	      $select_query1="SELECT * FROM pro100_answers WHERE question=".$arr[$i]["id"];
		  $st1=$db->query($select_query1);
	      $arr[$i]["num"]=count($st1->fetchAll());
		  $i++;
	  }
	  return($arr);	  	  
  }

  function get_questions($npage, $questions){
	  $col=$this->get_col();
	  $num=($npage-1)*$col;
	  $i=1;
	  $arr=array();
	  foreach ($questions as $k=>$arri){
		  if (($k>$num) and ($k<=$num+$col)){
			$arr[$i]=$arri;
			$i++;
		  }
	  }
	  return $arr;
  } 
  
  function get_question($id){
	  $db=new PDO('sqlite:db.sqlite');
	  $select_query="SELECT * FROM pro100_questions WHERE id=".$id;
	  $st=$db->query($select_query);
	  $arr=$st->fetch();
	  return($arr);
  }

  function get_answers($id, $npage){
	  $db=new PDO('sqlite:db.sqlite');
	  $col=$this->get_col();
	  $num=($npage-1)*$col;
	  $select_query1="SELECT * FROM pro100_answers WHERE question=".$id." ORDER BY id DESC";
	  $st1=$db->query($select_query1);
	  $arr=array();
	  $i=1;
	  $arr=array();
	  while($arri=$st1->fetch()){
		  if (($i>$num) and ($i<=$num+$col)){
	       $arr[$i]=$arri;
	      }
		$i++;
	  }
	  return($arr);
  }
  
  function q_count_pages($questions){
	$count=count($questions);
	$col=$this->get_col();//количество на странице
	$num=($count%$col==0)?$count/$col:($count-($count%$col))/$col+1;
	return($num);
  }

  function a_count_pages($q){
	  $db=new PDO('sqlite:db.sqlite');
	$select_query="SELECT * FROM pro100_answers WHERE question=".$q." ORDER BY id DESC";
	$st=$db->query($select_query);
	$count=count($st->fetchAll());
	$col=$this->get_col();//количество на странице
	$num=($count%$col==0)?$count/$col:($count-($count%$col))/$col+1;
	return($num);    
  }
  
  function findq($findtext){
    $db=new PDO('sqlite:db.sqlite');
	$qarr=array();
	$select_query="SELECT * FROM pro100_questions";
	$st=$db->query($select_query);
	$qs=$st->fetchAll();
	foreach ($qs as $k=>$next){
	  if (strpos(strtoupper($next["question"]),strtoupper($findtext)) !== FALSE)
	    $qarr[]=$next;
	}
	return $qarr;
  }
  
}